Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

<DefaultClassOptions()> _
<NavigationItem(False)> _
<CreatableItem(False)> _
Public Class FixedAssetsUsingRows
    Inherits BaseObject
    Private _FixedAssetsUsingHeader As FixedAssetsUsingHeader
    Private _FixedAssets As FixedAssets
    Private _ObjectCreated As Date
    Private _UserCreated As User

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()
        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub

    <Association("FixedAssetsUsingHeader-FixedAssetsUsingRows", GetType(FixedAssetsUsingHeader))> _
    Property FixedAssetsUsingHeader As FixedAssetsUsingHeader
        Get
            Return _FixedAssetsUsingHeader
        End Get
        Set(value As FixedAssetsUsingHeader)
            SetPropertyValue("FixedAssetsUsingHeader", _FixedAssetsUsingHeader, value)
        End Set
    End Property
    Property FixedAssets As FixedAssets
        Get
            Return _FixedAssets
        End Get
        Set(value As FixedAssets)
            SetPropertyValue("FixedAssets", _FixedAssets, value)
        End Set
    End Property
    <NonCloneable> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property
End Class
